/*****************************************************
In the name of God
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 08/28/2012
Author  : a_h_badr@yahoo.com
Company : SYNO
Comments: 


Chip type               : ATmega16
Program type            : Application
AVR Core Clock frequency: 1.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega16.h>
#include <stdlib.h>
#include <stdio.h>
#include <delay.h>
// Alphanumeric LCD Module functions
#include <alcd.h>

// Declare your global variables here
char str[16];
int amale;                            //tafkik bein 4 amal
int a;
int next;                             //baraye anjame amale jadid ba natige ghabli
float y,x,c=0;                        //2 addade morede nazar baraye mohasebat

// Declare your extra function here
void init (void);                     //karaye tekrarie har addad
void calc (void);                     //bedast avardane natige
void nextf (void);                     //baraye anjame amale jadid ba natige ghabli
    
void main(void)
{
// Declare your local variables here

PORTA=0x00;                           //port A baraye LCD
DDRA=0x00;

PORTD=0x0f;                           //port D baraye keypad
DDRD=0xf0;

// Alphanumeric LCD initialization
// Connections specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTA Bit 0
// RD - PORTA Bit 1
// EN - PORTA Bit 2
// D4 - PORTA Bit 4
// D5 - PORTA Bit 5
// D6 - PORTA Bit 6
// D7 - PORTA Bit 7
// Characters/line: 16
lcd_init(16);

lcd_clear();
lcd_gotoxy(0,0);
lcd_puts("AVR Calculator");
//lcd_gotoxy(0,1);
//lcd_puts("your name");
delay_ms(1000);
lcd_clear();
lcd_gotoxy(0,0);

while (1)
      {
      // Place your code here  
      loop:
      if(PIND==0x0f) goto loop;
      
      PORTD=0xef;
      if(PIND==0xee)                //7
        { 
        a=7;
        init();
        goto loop;
        }
      if(PIND==0xed)                //4
        {           
        a=4;
        init();
        goto loop;
        }
      if(PIND==0xeb)                //1
        {                          
        a=1;
        init();
        goto loop;
        }
      if(PIND==0xe7)                //C
        {                          
        x=0;
        y=0;
        lcd_clear();
        delay_ms(200); 
        goto loop;
        } 
        
      PORTD=0xdf;
      if(PIND==0xde)                //8
        { 
        a=8;
        init();
        goto loop;
        }
      if(PIND==0xdd)                //5
        {           
        a=5;
        init();
        goto loop;
        }
      if(PIND==0xdb)                //2
        {                          
        a=2;
        init();
        goto loop;
        }
      if(PIND==0xd7)                //0
        {                          
        a=0;
        init();
        goto loop;
        } 
      
      PORTD=0xbf;
      if(PIND==0xbe)                //9
        { 
        a=9;
        init();
        goto loop;
        }
      if(PIND==0xbd)                //6
        {           
        a=6;
        init();
        goto loop;
        }
      if(PIND==0xbb)                //3
        {                          
        a=3;
        init();
        goto loop;
        }
      if(PIND==0xb7)                //=
        {                          
        calc(); 
        goto loop;
        } 
          
      PORTD=0x7f;
      if(PIND==0x7e)                // /
        { 
        nextf(); 
        if(x!=0 && y==0)
            {
            y=x;
            x=0; 
            amale=1;                //amale /
            lcd_putchar('/');
            delay_ms(200);
            goto loop;
            }
        }
      if(PIND==0x7d)                //*
        {  
        nextf();          
        if(x!=0 && y==0)
            {
            y=x;
            x=0;                    //amale *
            amale=2;
            lcd_putchar('*');
            delay_ms(200);
            goto loop;
            }
        }
      if(PIND==0x7b)                //-
        {
        nextf();                          
        if(x!=0 && y==0)
            {
            y=x;
            x=0;         
            amale=3;                //amale -
            lcd_putchar('-');
            delay_ms(200);
            goto loop;
            }
        }
      if(PIND==0x77)                //+
        {  
        nextf();                       
        if(x!=0 && y==0)
            {
            y=x;
            x=0;     
            amale=4;                //amale +
            lcd_putchar('+');
            delay_ms(200);
            goto loop;
            }
        }            
      }
}

//*****************************************************/extra function

void init (void)                      //karaye tekrarie har addad
    {
    x=(x*10)+a; 
    if(x==0)    lcd_gotoxy(0,0);      //baraye inke 0 hey tekrar nashe 
    if(next==1)
        {
        lcd_clear();
        next=0;
        }
    itoa(a,str);                      //tabdile addad be aski baraye namayesh dar LCD
    lcd_puts(str);
    delay_ms(200);
    }  
    
void calc (void)                      //bedast avardane natige
    {
    if(x!=0 && y!=0)            //age 2 addad vared shide bashad angah be mohasebe mipardazad
            {
            switch (amale) 
                {
                case 1:
                y=(y/x);
                break;
                case 2: 
                y=(y*x);
                break;
                case 3: 
                y=(y-x);
                break;
                case 4:
                y=(y+x);
                break;
                } 
            lcd_gotoxy(0,1);
            lcd_putchar('=');
            ftoa(y,2,str);
            lcd_puts(str);
            lcd_gotoxy(0,0);
            c=y;
            x=0;
            y=0;
            next=1;
            } 
    if(x!=0 && y==0)          //age bade vared kardane avalin addad = ra bezanim faghat khode addad ra neshan midahad
            {
            lcd_gotoxy(0,1);
            lcd_putchar('=');
            ftoa(x,2,str);
            lcd_puts(str);
            lcd_gotoxy(0,0);
            c=x;
            x=0;   
            next=1;
            }
    delay_ms(200);
    }
    
void nextf (void)               //baraye anjame amale jadid ba natige ghabli  
    {         
    if(x!=0 && y!=0) calc();
    if(next==1)                 //baraye anjame amale jadid ba natige ghabli
            {
            x=c;
            c=0;
            next=0;
            lcd_puts("                ");
            lcd_gotoxy(0,0);
            ftoa(x,2,str);
            lcd_puts(str);
            } 
    }  
    
//*****************************************************/FINISH